;##################################################################
; EDIT with line numbers
;##################################################################

/*
Copyright notification:

This software is copyright 2004 Edgar Hansen
All rights not expressly granted are reserved.

It is free for any use including commercial without
requiring permission with the following exception:

It cannot be used in conjunction with RosAsm or
any program written with RosAsm. It cannot be used
in conjunction with any GPL application except with
special permission.
*/

;#include "\RadASM\GoAsm\inc\debug.a"
;DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
;DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists 

/*
Just fooling around

A custom line number control for standard edit boxes

The control is self sizing and updating
It must be the child of an edit control and the application must update the
control (UpdateWindow) when the edit is scrolled. It supports the following messages

WM_SETFONT = Sets the font for the line numbers
LCM_SETBKCOLOR = Sets the background color for the control (wParam = color)
LCM_SETTXTCOLOR = Sets the text color for the line numbers (wParam = color)
LCM_AUTOSIZE = Causes the control to resize itself, do this if the edit size changes
LCM_SETHILITECOLOR = Sets the background color for hilited line numbers (wParam = color)
LCM_SETHILITEBDR = Sets the border color for hilited line numbers (wParam = color)
LCM_SETHILITES = Provides a pointer to an array of line numbers to be hilited
					wParam = pointer to the array, lParam = size of the array
*/

; ANSI APIS
GetModuleHandle = GetModuleHandleA
CreateFontIndirect = CreateFontIndirectA
DialogBoxParam = DialogBoxParamA
CreateWindowEx = CreateWindowExA
SendMessage = SendMessageA
FindWindowEx = FindWindowExA
PostMessage = PostMessageA
SetWindowLong = SetWindowLongA
GetTextExtentPoint32 = GetTextExtentPoint32A
GetWindowLong = GetWindowLongA
DefWindowProc = DefWindowProcA
DrawText = DrawTextA
LoadCursor = LoadCursorA
RegisterClassEx = RegisterClassExA

; WINDOWS CONSTANTS
#Define NULL 0
#Define TRUE 1
#Define FALSE 0

#Define WM_USER 400h
#Define WM_INITDIALOG 110h
#Define WM_COMMAND 111h
#Define WM_CLOSE 10h
#Define WM_CTLCOLOREDIT 133h
#Define WM_SETFONT 30h
#Define WM_CREATE 1h
#Define WM_PAINT 0Fh
#Define WM_RBUTTONUP 205h
#Define WM_LBUTTONUP 202h
#Define WM_LBUTTONDBLCLK 203h
#Define WM_LBUTTONDOWN 201h

#Define WM_WINDOWPOSCHANGED 47h
#Define WM_GETMINMAXINFO 24h
#Define WM_ENTERSIZEMOVE 231h
#Define WM_EXITSIZEMOVE 232h
#Define WM_ERASEBKGND 14h

#Define EM_GETFIRSTVISIBLELINE 0CEh
#Define EM_LINEFROMCHAR 0C9h
#Define EM_CHARFROMPOS 0D7h
#Define EM_GETRECT 0B2h
#Define EM_SETRECT 0B3h
#Define EM_SETSEL 0B1h
#Define EM_LINELENGTH 0C1h

#Define WS_CHILD 40000000h
#Define WS_BORDER 800000h
#Define WS_VISIBLE 10000000h
#Define WS_VSCROLL 200000h

#Define SW_HIDE 0
#Define SW_SHOW 5

#Define ES_WANTRETURN 1000h
#Define ES_AUTOVSCROLL 40h
#Define ES_MULTILINE 4h

#Define DT_CENTER 1h
#Define DT_SINGLELINE 20h
#Define DT_BOTTOM 8h

#Define DEFAULT_GUI_FONT 17
#Define SWP_NOZORDER 4h
#Define SWP_NOMOVE 2h
#Define TRANSPARENT 1
#Define PS_SOLID 0
#Define SRCCOPY 0CC0020h
#Define DWL_MSGRESULT 0

#Define COLOR_BTNFACE 15
#Define IDC_HAND 32649

#Define CS_VREDRAW 1h
#Define CS_HREDRAW 2h
#Define CS_OWNDC 20h
#Define LF_FACESIZE 32

; STRUCTURES

LOGFONT STRUCT
  lfHeight          DD
  lfWidth           DD
  lfEscapement      DD
  lfOrientation     DD
  lfWeight          DD
  lfItalic          DB
  lfUnderline       DB
  lfStrikeOut       DB
  lfCharSet         DB
  lfOutPrecision    DB
  lfClipPrecision   DB
  lfQuality         DB
  lfPitchAndFamily  DB
  lfFaceName        DB LF_FACESIZE dup 0
LOGFONT ENDS

RECT STRUCT
  left    dd
  top     dd
  right   dd
  bottom  dd
RECT ENDS

POINT STRUCT
  x  DD
  y  DD
POINT ENDS

PAINTSTRUCT STRUCT
  hdc           DD
  fErase        DD
  rcPaint       RECT <0>
  fRestore      DD
  fIncUpdate    DD
  rgbReserved   DB 32 dup 0
PAINTSTRUCT ENDS

WNDCLASSEX STRUCT
  cbSize            DD
  style             DD
  lpfnWndProc       DD
  cbClsExtra        DD
  cbWndExtra        DD
  hInstance         DD
  hIcon             DD
  hCursor           DD
  hbrBackground     DD
  lpszMenuName      DD
  lpszClassName     DD
  hIconSm           DD
WNDCLASSEX ENDS

MINMAXINFO STRUCT
  ptReserved        POINT         <0>
  ptMaxSize         POINT         <0>
  ptMaxPosition     POINT         <0>
  ptMinTrackSize    POINT         <0>
  ptMaxTrackSize    POINT         <0>
MINMAXINFO ENDS

CONST SECTION
	TOPMSG		equ	WM_USER+1023
	IDD_DLG1	equ	1000
	IDC_EDT1	equ	1001
	IDC_LINEBAR	equ	32767

	LCM_SETBKCOLOR = WM_USER+512
	LCM_SETTXTCOLOR = WM_USER+513
	LCM_AUTOSIZE = WM_USER+514
	LCM_SETHILITECOLOR = WM_USER+515
	LCM_SETHILITEBDR = WM_USER+516
	LCM_SETHILITES = WM_USER+517
	WM_CTLCOLORBOOKMARK = WM_USER+518
	
	LCN_RBTNCLICK = WM_USER+519
	LCN_RBTNDBLCLICK = WM_USER+520

	MINWIDTH = 300
	MINHEIGHT = 200

DATA SECTION
	MsgTable	DD		TOPMSG*4 DUP (?)
	hInstance	DD		?
	hEdit		DD		?
	DefEditProc	DD		?
	DefStaticProc	DD	?
	icc	 		DQ		3FFF00000008h
	hFillBrush	DD		?
	hSelbar		DD		?
	hSelbarFont	DD		?
	hEditFont	DD		?
	IsMoving	DD		?
	RedBrush	DD		?
	GreenBrush	DD		?
	hDlg		DD		?
	
	Arial_Narrow_9 LOGFONT <-12,0,0,0,400,0,0,0,0,3,2,1,34,"Arial Narrow">
	Courier_10 LOGFONT <-13,0,0,0,400,0,0,0,0,1,2,1,49,"Courier">

	LINEARRAY	DD		4,1,2,3,9,0,0,0,19,0,0,0

CODE SECTION

BuildMessageTable:
	uses edi,ecx,eax
	; Set the default proc for all messages to WM_USER+1023
	mov edi,OFFSET MsgTable
	mov ecx,TOPMSG-1
	mov eax,OFFSET DEFPROC
	rep stosd
	; Set the offsets of the messages to process
	mov [MsgTable+(WM_INITDIALOG *4)],OFFSET WMINITDIALOG
	mov [MsgTable+(WM_COMMAND *4)],OFFSET WMCOMMAND
	mov [MsgTable+(WM_CLOSE *4)],OFFSET WMCLOSE
	mov [MsgTable+(WM_CTLCOLOREDIT *4)],OFFSET WMCTLCOLOREDIT
	mov [MsgTable+(WM_WINDOWPOSCHANGED *4)],OFFSET WMWINDOWPOSCHANGED
	mov [MsgTable+(WM_GETMINMAXINFO *4)],OFFSET WMGETMINMAXINFO
	mov [MsgTable+(WM_ENTERSIZEMOVE *4)],OFFSET WMENTERSIZEMOVE
	mov [MsgTable+(WM_EXITSIZEMOVE *4)],OFFSET WMEXITSIZEMOVE
	mov [MsgTable+(WM_ERASEBKGND *4)],OFFSET WMERASEBKGND
	mov [MsgTable+(WM_CTLCOLORBOOKMARK *4)],OFFSET WMCTLCOLORBOOKMARK
	mov [MsgTable+(LCN_RBTNCLICK *4)],OFFSET LCNRBTNCLICK
	mov [MsgTable+(LCN_RBTNDBLCLICK *4)],OFFSET LCNRBTNDBLCLICK
	ret
	endu

Start:
	call BuildMessageTable
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControlsEx,OFFSET icc
	invoke InitLineBarClass
	invoke CreateFontIndirect,offset Arial_Narrow_9
	mov [hSelbarFont],eax
	invoke CreateFontIndirect,offset Courier_10
	mov [hEditFont],eax
	invoke CreateSolidBrush,000000FFh
	mov [RedBrush],eax
	invoke CreateSolidBrush,0080FF80h
	mov [GreenBrush],eax
	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	invoke DeleteObject,[hSelbarFont]
	invoke DeleteObject,[hEditFont]
	invoke DeleteObject,[RedBrush]
	invoke DeleteObject,[GreenBrush]
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL rect		:RECT
	LOCAL line[16]	:B

	mov eax,[uMsg]
	cmp eax,TOPMSG-1
	ja >DEFPROC
	jmp [MsgTable+eax*4]

	WMINITDIALOG:
		mov eax,[hwnd]
		mov [hDlg],eax
		invoke GetClientRect,[hwnd],offset rect
		invoke CreateWindowEx,NULL,"Edit",NULL,WS_BORDER \
			+WS_CHILD+WS_VISIBLE+ES_MULTILINE+ES_WANTRETURN \
			+ES_AUTOVSCROLL+WS_VSCROLL,0,0,[rect.right],[rect.bottom],[hwnd],\
			IDC_EDT1,[hInstance],NULL
		mov [hEdit],eax
		invoke SendMessage,[hEdit],WM_SETFONT,[hEditFont],TRUE

		; Create the line bar, it is autosizing and positioning so any size
		; paramters are ignored
		invoke CreateWindowEx,NULL,"UDC_LineBar",NULL,WS_CHILD+WS_VISIBLE,\
			0,0,0,0,[hEdit],IDC_LINEBAR,[hInstance],NULL
		mov [hSelbar],eax
		; You can send the following messages

		invoke SendMessage,[hSelbar],WM_SETFONT,[hSelbarFont],TRUE
		invoke SendMessage,[hSelbar],LCM_SETBKCOLOR,00C08080h,NULL
		invoke SendMessage,[hSelbar],LCM_SETTXTCOLOR,00FF0000h,NULL
		invoke SendMessage,[hSelbar],LCM_SETHILITECOLOR,0093FFFFh,NULL
		invoke SendMessage,[hSelbar],LCM_SETHILITEBDR,0,NULL
		invoke SendMessage,[hSelbar],LCM_SETHILITES,offset LINEARRAY,SIZEOF LINEARRAY

		invoke SendMessage,[hSelbar],LCM_AUTOSIZE,NULL,NULL
		jmp >>.EXIT

	WMCOMMAND:
		movzx eax,W[wParam+2]
		movzx ecx,W[wParam]

		jmp >>.EXIT

	WMCLOSE:
		INVOKE EndDialog,[hwnd],0

	WMCTLCOLOREDIT:
		; Update the line bar with the edit control
		; You would normally not do this here, instead during the
		; scrolling but I did not want to bother implementing the scrolling
		invoke FindWindowEx,[lParam],NULL,"UDC_LineBar",NULL
		or eax,eax
		jz >DEFPROC
			push eax
			invoke InvalidateRect,eax,NULL,FALSE
			pop eax
			invoke UpdateWindow,eax
			mov eax,NULL
			ret

	WMCTLCOLORBOOKMARK:
		cmp D[lParam],15
		jne >
		invoke SetWindowLong,[hwnd],DWL_MSGRESULT,[RedBrush]
		:
		cmp D[lParam],23
		jne >
		invoke SetWindowLong,[hwnd],DWL_MSGRESULT,[GreenBrush]
		:
		mov eax,TRUE
		ret

	LCNRBTNCLICK:
		; The R mouse button was clicked
		; wParam = hControl
		; lParam = Line number (0 if no over a valid line)
		ret

	LCNRBTNDBLCLICK:
		; The R mouse button was double clicked
		; wParam = hControl
		; lParam = Line number (0 if no over a valid line)
		ret

	WMERASEBKGND:
		cmp D[IsMoving],TRUE
		jne >>DEFPROC
		xor eax,eax
		inc eax
		ret

	WMENTERSIZEMOVE:
		invoke FindWindowEx,[hEdit],NULL,"UDC_LineBar",NULL
		or eax,eax
		jz >
		; Just cheating here so the resize and move doesn't
		; have to be handled in the edit window proc as well
		; hide the line bar and there is no problem...
		invoke ShowWindow,eax,SW_HIDE
		:
		mov D[IsMoving],TRUE
		xor eax,eax
		ret

	WMEXITSIZEMOVE:
		mov D[IsMoving],FALSE
		invoke InvalidateRect,[hwnd],NULL,TRUE
		invoke UpdateWindow,[hwnd]
		invoke LockWindowUpdate,NULL
		invoke FindWindowEx,[hEdit],NULL,"UDC_LineBar",NULL
		or eax,eax
		jz >
			push eax
			invoke ShowWindow,eax,SW_SHOW
			pop eax
			invoke SendMessage,eax,LCM_AUTOSIZE,0,0
		:
		xor eax,eax
		ret

	WMGETMINMAXINFO:
		mov edi,[lParam]
		mov D[edi+MINMAXINFO.ptMinTrackSize.x],MINWIDTH
		mov D[edi+MINMAXINFO.ptMinTrackSize.y],MINHEIGHT
		xor eax,eax
		ret

	WMWINDOWPOSCHANGED:
		invoke GetClientRect,[hwnd],offset rect
		invoke SetWindowPos,[hEdit],NULL,0,0,[rect.right],[rect.bottom],SWP_NOZORDER
		invoke FindWindowEx,[hEdit],NULL,"UDC_LineBar",NULL
		or eax,eax
		jz >
			invoke SendMessage,eax,LCM_AUTOSIZE,0,0
		:
		jmp >>.EXIT

	DEFPROC:
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

LineBarProc FRAME hwnd,uMsg,wParam,lParam
	uses edi
	LOCAL ps		:PAINTSTRUCT
	LOCAL rect		:RECT
	LOCAL pt		:POINT
	LOCAL hParent	:D

	cmp D[uMsg],WM_CREATE
	jne >>
		invoke GetStockObject,DEFAULT_GUI_FONT
		push eax
		invoke PostMessage,[hwnd],WM_SETFONT,eax,TRUE
		pop eax
		invoke SetWindowLong,[hwnd],0,eax
		invoke SetWindowLong,[hwnd],4,00C08080h
		invoke SetWindowLong,[hwnd],8,0
		invoke SetWindowLong,[hwnd],12,00AAFFAAh
		invoke SetWindowLong,[hwnd],16,00004000h
		invoke SetWindowLong,[hwnd],20,0

		invoke GetParent,[hwnd]
		invoke SetWindowLong,[hwnd],28,eax

		invoke GetDoubleClickTime
		mov [DblClkSpeed],eax
	:

	cmp D[uMsg],WM_PAINT
	jne >
		invoke BeginPaint,[hwnd],offset ps
		invoke GetWindowLong,[hwnd],28
		invoke SendMessage,eax,EM_GETFIRSTVISIBLELINE,0,0
		invoke DrawLineNumbers,[hwnd],eax
		invoke EndPaint,[hwnd],offset ps
		xor eax,eax
		ret
	:

	cmp D[uMsg],WM_SETFONT
	jne >
		invoke SetWindowLong,[hwnd],0,[wParam]
		cmp D[lParam],TRUE
		jne >
			invoke PostMessage,[hwnd],LCM_AUTOSIZE,0,0
	:

	cmp D[uMsg],LCM_SETHILITECOLOR
	jne >
		invoke SetWindowLong,[hwnd],12,[wParam]
	:

	cmp D[uMsg],LCM_SETHILITEBDR
	jne >
		invoke SetWindowLong,[hwnd],16,[wParam]
	:

	cmp D[uMsg],LCM_SETBKCOLOR
	jne >
		invoke SetWindowLong,[hwnd],4,[wParam]
	:

	cmp D[uMsg],LCM_SETTXTCOLOR
	jne >
		invoke SetWindowLong,[hwnd],8,[wParam]
	:

	cmp D[uMsg],LCM_SETHILITES
	jne >
		invoke SetWindowLong,[hwnd],20,[wParam]
		mov eax,[lParam]
		shr eax,2
		invoke SetWindowLong,[hwnd],24,eax
	:

	cmp D[uMsg],LCM_AUTOSIZE
	jne >>
		invoke GetDC,[hwnd]
		mov edi,eax
		invoke GetWindowLong,[hwnd],0
		invoke SelectObject,edi,eax
		invoke GetTextExtentPoint32,edi,"0000",4,offset pt
		invoke ReleaseDC,[hwnd],edi

		invoke GetWindowLong,[hwnd],28
		mov [hParent],eax

		invoke GetClientRect,[hParent],offset rect
		mov eax,[pt.x]
		add D[rect.left],eax
		sub D[rect.right],eax
		invoke SendMessage,[hParent],EM_SETRECT,0,offset rect

		sub D[rect.bottom],2 ; adjust to 2* border height
		invoke SetWindowPos,[hwnd],NULL,1,1,[pt.x],\
				[rect.bottom], SWP_NOZORDER
		add D[rect.bottom],2
		invoke InvalidateRect,[hwnd],NULL,FALSE
		invoke UpdateWindow,[hwnd]
	:

	cmp D[uMsg],WM_RBUTTONUP
	jne >>
		invoke GetWindowLong,[hwnd],28
		mov [hParent],eax
		movzx eax,W[lParam]
		mov [pt.x],eax
		movzx eax,W[lParam+2]
		mov [pt.y],eax
		invoke MapWindowPoints,[hwnd],[hParent],offset pt,1
		mov eax,[pt.y]
		shl eax,16
		mov ax,16
		invoke SendMessage,[hParent],EM_CHARFROMPOS,0,eax
		shr eax,16
		mov edi,eax

		; Get the parent of the edit to send the message to
		invoke GetParent,[hParent]
		mov [hParent],eax

		invoke GetTickCount
		mov edx,eax
		sub edx,[TickCount]
		mov [TickCount],eax
		cmp edx,[DblClkSpeed]
		jle >D0
			inc edi
			invoke PostMessage,[hParent],LCN_RBTNCLICK,[hwnd],edi
			ret
		D0:
			inc edi
			invoke PostMessage,[hParent],LCN_RBTNDBLCLICK,[hwnd],edi
			ret
	:

	cmp D[uMsg],WM_LBUTTONUP
	jne >>
		invoke GetWindowLong,[hwnd],28
		mov [hParent],eax
		movzx eax,W[lParam]
		mov [pt.x],eax
		movzx eax,W[lParam+2]
		mov [pt.y],eax
		invoke MapWindowPoints,[hwnd],[hParent],offset pt,1
		mov eax,[pt.y]
		shl eax,16
		mov ax,16
		invoke SendMessage,[hParent],EM_CHARFROMPOS,0,eax
		and eax,0ffffh
		mov edi,eax
		
		invoke GetTickCount
		mov edx,eax
		sub edx,[TickCount]
		mov [TickCount],eax
		cmp edx,[DblClkSpeed]
		jle >>D1
			; Single click
			invoke SendMessage,[hParent],EM_SETSEL,edi,edi
			jmp >
		D1:
			; double click
			invoke SendMessage,[hParent],EM_LINELENGTH,edi,0
			add eax,edi
			invoke SendMessage,[hParent],EM_SETSEL,edi,eax
	:

	invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
	RET

	DATA SECTION
	TickCount	DD		?
	DblClkSpeed	DD		?
	CODE SECTION
ENDF

DrawLineNumbers FRAME hwnd,TopIndex
	uses ebx,esi,edi
	LOCAL rect			:RECT
	LOCAL clRect		:RECT
	LOCAL pt			:POINT
	LOCAL hEditCntl		:D
	LOCAL height		:D
	LOCAL memBmp		:D
	LOCAL memDC			:D
	LOCAL OldObj		:D
	LOCAL line[16]		:B
	LOCAL hBkBrush		:D
	LOCAL hlcolor		:D
	LOCAL hlborder		:D

	invoke GetWindowLong,[hwnd],12
	mov [hlcolor],eax
	invoke GetWindowLong,[hwnd],16
	mov [hlborder],eax

	invoke GetWindowLong,[hwnd],4
	invoke CreateSolidBrush,eax
	mov [hBkBrush],eax

	invoke GetDC,[hwnd]
	mov ebx,eax
	invoke CreateCompatibleDC,eax
	mov [memDC],eax

	mov esi,[TopIndex]
	inc esi
	invoke GetClientRect,[hwnd],offset clRect
	mov eax,[clRect.bottom]
	mov [height],eax

	invoke CreateCompatibleBitmap,ebx,[clRect.right],[clRect.bottom]
	mov [memBmp],eax
	invoke SelectObject,[memDC],eax
	mov [OldObj],eax

	; Get the height of a line in the Edit control
	invoke GetWindowLong,[hwnd],28
	mov [hEditCntl],eax
	invoke GetDC,[hEditCntl]
	mov edi,eax
	invoke SelectObject,edi,[hEditFont]
	invoke GetTextExtentPoint32,edi,"Hello",5,offset pt
	invoke ReleaseDC,[hEditCntl],edi

	invoke FillRect,[memDC],offset clRect,[hBkBrush]

	mov D[rect.top],0
	mov D[rect.left],0
	mov eax,[clRect.right]
	mov D[rect.right],eax
	mov edi,1 ; top border
	mov eax,[pt.y]
	add eax,1 ; top border
	mov D[rect.bottom],eax

	invoke GetWindowLong,[hwnd],0
	invoke SelectObject,[memDC],eax
	invoke SetBkMode,[memDC],TRANSPARENT
	invoke GetWindowLong,[hwnd],8
	invoke SetTextColor,[memDC],eax

	:
		mov [rect.top],edi
		invoke dw2ascii,esi,offset line
		; Draw the color background here if necessary
		; Need an array of line numbers and have to check against it
		push edi
		invoke GetWindowLong,[hwnd],20
		mov edi,eax
		or edi,edi
		jz >>B1
		invoke GetWindowLong,[hwnd],24
		mov ecx,eax
		mov eax,[TopIndex] ; TopIndex contains the 0 based line number being processed
		inc eax
		repne scasd
		or ecx,ecx
		jz >>B0
			; This draws the green (or app defined) border and background 
			invoke CreateSolidBrush,[hlcolor]
			push eax
			invoke SelectObject,[memDC],eax
			push eax
			invoke CreatePen,PS_SOLID,1,[hlborder]
			push eax
			invoke SelectObject,[memDC],eax
			push eax
			invoke RoundRect,[memDC],[rect.left],[rect.top],\
				[rect.right],[rect.bottom],10,10
			pop eax
			invoke SelectObject,[memDC],eax
			pop eax
			invoke DeleteObject,eax
			pop eax
			invoke SelectObject,[memDC],eax
			pop eax
			invoke DeleteObject,eax
			jmp >>B1
		B0:
			; Message Callback for color
			invoke GetParent,[hEditCntl]
			mov edx,eax
			mov eax,[TopIndex]
			inc eax
			invoke SendMessage,edx,WM_CTLCOLORBOOKMARK,[hwnd],eax
			or eax,eax
			jz >B1
				invoke SelectObject,[memDC],eax
				push eax
				invoke CreatePen,PS_SOLID,1,[hlborder]
				push eax
				invoke SelectObject,[memDC],eax
				push eax
				invoke RoundRect,[memDC],[rect.left],[rect.top],\
					[rect.right],[rect.bottom],10,10
				pop eax
				invoke SelectObject,[memDC],eax
				pop eax
				invoke DeleteObject,eax
				pop eax
				invoke SelectObject,[memDC],eax
		B1:
		pop edi

		invoke DrawText,[memDC],offset line,-1,offset rect,\
			DT_CENTER + DT_SINGLELINE + DT_BOTTOM
		add esi,1
		mov eax,[pt.y]
		add D[rect.bottom],eax
		add edi,eax
		inc D[TopIndex]
		cmp edi,[height]
	jl <<

	invoke BitBlt,ebx,0,0,[clRect.right],[clRect.bottom],[memDC],0,0,SRCCOPY
	invoke SelectObject,[memDC],[OldObj]
	invoke DeleteObject,[memBmp]
	invoke DeleteObject,[hBkBrush]
	invoke DeleteDC,[memDC]
	invoke ReleaseDC,[hwnd],ebx
	RET
ENDF

InitLineBarClass FRAME
	LOCAL wcx		:WNDCLASSEX

	/*
	cbWndExtra table of values:
		0 = Font
		4 = Background color
		8 = Text color
		12 = HILITE Color
		16 = HILITE Border color
		20 = Pointer to array of hilited lines
		24 = Array count
		28 = Parent of the line control
	*/

	mov D[wcx.cbSize],SIZEOF WNDCLASSEX
	mov D[wcx.style], CS_HREDRAW + CS_VREDRAW + CS_OWNDC
	mov eax,[hInstance]
	mov D[wcx.hInstance],eax
	mov D[wcx.lpszClassName],OFFSET UDC_LineBarClass
	mov D[wcx.cbClsExtra],0
	mov D[wcx.cbWndExtra],32
	mov D[wcx.lpfnWndProc],OFFSET LineBarProc
	mov D[wcx.hIcon],NULL
	mov D[wcx.hIconSm],NULL
	mov D[wcx.hbrBackground],COLOR_BTNFACE+1
	mov D[wcx.lpszMenuName],NULL

	invoke LoadCursor,NULL,IDC_HAND
	mov [wcx.hCursor],eax

	invoke RegisterClassEx,ADDR wcx

	ret

	UDC_LineBarClass:	DB		"UDC_LineBar",0

ENDF

dw2ascii FRAME dwValue,lpBuffer
	uses ebx,edi

	; By MichaelW and pdixon

		mov eax,[dwValue]
		mov ecx,2814749768
		mov edi,[lpBuffer]

		or eax,eax
		jns >S1
		neg eax
		mov B[edi],"-"
		inc edi

S1:
	push eax
;	#####fast div by 100000
		mul ecx
		mov ecx,100000
		shr edx,16
		mov eax,edx
		mov ebx,edx
		mul ecx
	sub [esp],eax

		mov eax,ebx
		mov ecx,429497
		mov ebx,10

		or eax,eax
		jz >S5

;	#######part 1
		mul ecx
		jc >D1

		mul ebx
		jc >D2

		mul ebx
		jc >D3

		mul ebx
		jc >D4

		mul ebx
		jc >D5
S5:
	pop eax
		mul ecx
		jc >D6

		mul ebx
		jc >D7

		mul ebx
		jc >D8

		mul ebx
		jc >D9

		mul ebx
		jmp >D0

;	#####end part1

D1:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D2:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D3:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D4:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D5:
		add edx,30h
		mov [edi],dl

	pop eax

		mul ecx
		inc edi
D6:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D7:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D8:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D9:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D0:
		add edx,30h
		mov [edi],dx

	mov eax,[dwValue]
	RET
ENDF
